-- debug 参数
sNeedGuest = false --允许输入帐号
sScelet = false --允许选服
sRemAccount = true --记住帐号
sServerProxy = true --后台控制选服
sDebugMaja = false  -- 马甲逻辑测试
sDebugMajaIndex = 3 -- 马甲逻辑测试

-- 废弃了，改用后台控制
-- sShare = false -- true 表示是我们自己的分享包（只留手机号登录）(FB和游客的总控开关)
-- sYouke = false  --true 表示打开游客登录（sShare为true时判断）

-- 当前平台
local targetPlatform = cc.Application:getInstance():getTargetPlatform()

-- 文件处理工具
local fileUtils = cc.FileUtils:getInstance()

-- bugly native
local funcPostLuaException = function()
    --TODO
end

-- luaide debug
local USE_LUAIDE_DEBUG = true
local breakInfoFun, XPCallFun = nil, nil
if USE_LUAIDE_DEBUG then
    local sharedApplication = cc.Application:getInstance()
    local target = sharedApplication:getTargetPlatform() --ApplicationProtocol类里面的对应有相应的枚举
    _G.isLuaDebug = _G.isLuaDebug or false
    if target < 3 and not _G.isLuaDebug then
        _G.isLuaDebug = true
        breakInfoFun, XPCallFun = require("luaide/LuaDebugjit")("localhost", 7003)
        cc.Director:getInstance():getScheduler():scheduleScriptFunc(breakInfoFun, 0.5, false)
    end
end

-- android
if targetPlatform == 3 then
    funcPostLuaException = function(strError, strStack)
        local javaClassName = "org/cocos2dx/lua/NativeLuaBridge"
        local javaMethodName = "postLuaException"
        local javaParams = {strError, strStack}
        local javaMethodSig = "(Ljava/lang/String;Ljava/lang/String;)V"
        luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
    end
end

-- ios
if targetPlatform == 4 or targetPlatform == 5 then
    funcPostLuaException = function(strError, strStack)
        local param = {
            strError = strError,
            strStack = strStack
        }
        luaoc.callStaticMethod("NativeLuaBridge", "postLuaException", param)
    end
end

-- oyhp windows下脚本默认卸载便于调试
if targetPlatform == 0 then
    local userDefault = cc.UserDefault:getInstance()
    if userDefault:getBoolForKey("__test_request", false) then
        local _require = require
        require = function(filePath, data)
            local id = nil
            data = data or {}
            local bSuccessed, result =
                pcall(
                function()
                    return _require(filePath, data)
                end
            )
            if not bSuccessed then
                package.loaded[filePath] = nil
                __G__TRACKBACK__(result)
                return
            end
            --“标记dontClean”和“原生库”不会被清理，注意：“原生库”这是弱检测，
            if (not data.dontClean and not string.find(filePath, "^[%w_]+$")) or data.force then
                id =
                    cc.Director:getInstance():getScheduler():scheduleScriptFunc(
                    function()
                        package.loaded[filePath] = nil
                        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(id)
                    end,
                    0,
                    false
                )
            end
            return result
        end
    end
end

-- oyhp 避免影响大家，PC平台下，这里加载一个git忽略的lua文件
if targetPlatform == 0 and fileUtils:isFileExist(fileUtils:fullPathForFilename("test_config.lua")) then
    require("test_config", {force = true})
end

function __G__TRACKBACK__(errorMessage)
    print("----------------------------------------")
    print("LUA ERROR: " .. tostring(errorMessage) .. "\n")
    print(debug.traceback("", 2))
    print("----------------------------------------")

    funcPostLuaException(errorMessage, debug.traceback())

    --选服状态，开启报错提示
    if sScelet then
        -- oyhp 优先显示上一个错误
        if not tolua.isnull(__lastErrorView) then
            return
        end
        local offset = 10
        local width = display.width * 0.8
        local _errorMessage = errorMessage
        local _traceback = debug.traceback("", 2)
        local listView = ccui.ListView:create()
        listView:setDirection(ccui.ScrollViewDir.vertical)
        listView:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
        listView:setBackGroundColor(cc.c3b(0, 0, 0))
        listView:setBounceEnabled(true)
        listView:setTouchEnabled(true)
        local content =
            display.newTTFLabel(
            {
                text = "【GAME ERROR】:" .. "\n" .. _errorMessage .. "\n" .. _traceback,
                font = "Arial",
                size = 18,
                color = cc.c3b(255, 0, 0),
                align = cc.ui.TEXT_ALIGN_LEFT,
                valign = cc.ui.TEXT_VALIGN_TOP,
                dimensions = cc.size(width - offset * 2, 0)
            }
        )
        listView:align(display.CENTER, display.cx, display.cy)
        listView:setContentSize(cc.size(width, display.height / 2))

        local textButton = ccui.Button:create()
        textButton:setTouchEnabled(true)
        textButton:setTitleText("close")
        textButton:setTitleFontSize(30)
        textButton:setTitleColor(cc.c3b(255, 0, 0))
        textButton:addTouchEventListener(
            function(sender, eventType)
                if eventType == ccui.TouchEventType.began then
                    __lastErrorView = nil
                    listView:removeSelf()
                    return true
                end
            end
        )
        listView:pushBackCustomItem(textButton)

        local Layout_item = ccui.Layout:create()
        Layout_item:setContentSize(cc.size(width, content:getContentSize().height + offset * 2))
        content:setPosition(content:getContentSize().width / 2 + offset, content:getContentSize().height / 2 + offset)
        Layout_item:addChild(content)
        listView:pushBackCustomItem(Layout_item)
        EventHelp.registerEvent(
            listView,
            "ClickKeyback",
            function()
                __lastErrorView = nil
                listView:removeSelf()
            end
        )
        -- oyhp 切换场景时报错会报到上一个场景，所以这里延迟一帧处理
        listView:retain()
        __lastErrorView = listView
        runInNextFrame(
            function()
                display.getRunningScene():addChild(listView, cc.INT_MAX)
                listView:release()
            end,
            listView
        )
    end
end

-- 测试马甲包代码
if sDebugMaja then
    package.path = package.path .. ";src" .. sDebugMajaIndex .. "/"
    --设置SearchPaths
    local oldSearchPaths = fileUtils:getSearchPaths()
    for i, v in ipairs(oldSearchPaths) do
        print("old````````````", v)
    end
    local searchPaths = {}
    table.insert(searchPaths, fileUtils:getWritablePath() .. "upd/")
    table.insert(searchPaths, fileUtils:getWritablePath() .. "upd/ccbResources/")
    table.insert(searchPaths, "res" .. sDebugMajaIndex .. "/")
    table.insert(searchPaths, "src" .. sDebugMajaIndex .. "/")
    table.insert(searchPaths, "res/")
    table.insert(searchPaths, "src/")
    table.insert(searchPaths, fileUtils:getWritablePath())
    fileUtils:setSearchPaths(searchPaths)
    --设置SearchPaths
    local newSearchPaths = fileUtils:getSearchPaths()
    for i, v in ipairs(newSearchPaths) do
        print("new````````````", v)
    end
end

package.path = package.path .. ";src/"

fileUtils:setPopupNotify(false)
-- 清除fileCached 避免无法加载新的资源。
fileUtils:purgeCachedEntries()

require("config")
require("native")

local isUpd = false
local updZip = false
if cc.Application:getInstance():getTargetPlatform() ~= 0 then
    isUpd = true
    updZip = false
end

cc.LuaLoadChunksFromZIP("lib/src_app_cocos.zip")
cc.LuaLoadChunksFromZIP("lib/src_framework.zip")
cc.LuaLoadChunksFromZIP("lib/src_script.zip")
cc.LuaLoadChunksFromZIP("lib/src_game.zip")
cc.LuaLoadChunksFromZIP("lib/src_launcher.zip")

_G.isUpd = isUpd

require("app.MyApp").new():run()
